/**
 * Error handling code.
 * 
 * @author    Andy Frank
 * @creation  27 Dec 04
 */

////////////////////////////////////////////////////////////////
// Error Codes
////////////////////////////////////////////////////////////////

var ERROR_OK = 0;
var ERROR_INVALID_FEED_URL = 1;
var ERROR_UNKNOWN_FEED_FORMAT = 2;

/**
 * Get a human readable summary of error.
 */
function getErrorSummary(code)
{
  switch (code)
  {
    case ERROR_OK: 
      return "This feed is functioning properly";
    case ERROR_INVALID_FEED_URL:
      return "Invalid feed URL";
    case ERROR_UNKNOWN_FEED_FORMAT:
      return "Unknown feed format";
    default: return "Parse Error";
  }
} 

/**
 * Get possible remedies for this error.
 */
function getErrorRemedies(code)
{
  // TODO - break out into HTML referenced by ID
  switch (code)
  {
    case ERROR_OK: return "";
    case ERROR_INVALID_FEED_URL:
      return "The feed url is invalid.  Check to make sure the URL is correct.";
    case ERROR_UNKNOWN_FEED_FORMAT:
      return "NewsFox does not recognize this feed format. NewsFox "+
        "supports RSS 0.91,0.92,2.0, and Atom 0.3,1.0.  If this feed uses " +
        "one of those formats then email me a bug report.  Be sure to " + 
        "include the feed url and this error code.";        
    default: return code;
  }
}
