/**
 * OPML import/export methods.
 * 
 * @author    Andy Frank
 * @creation  27 Apr 05
 */

////////////////////////////////////////////////////////////////
// Export OPML
////////////////////////////////////////////////////////////////

function exportOpml()
{
  var picker = Components.classes["@mozilla.org/filepicker;1"].
    createInstance(Components.interfaces.nsIFilePicker);
  picker.init(window, "Export OPML", picker.modeSave);
  picker.appendFilter("OPML Files (*.xml, *.opml)", "*.xml;*.opml");
  picker.appendFilters(picker.filterAll);
  picker.defaultString = "newsfox.opml";
  
  var result = picker.show();
  if(result == picker.returnOK || result == picker.returnReplace) 
  {
    try 
    {
      var file = Components.classes['@mozilla.org/file/local;1'].
        createInstance(Components.interfaces.nsILocalFile);
      file.initWithPath(picker.file.path);
      if(file.exists()) file.remove(true);
      
      file.create(file.NORMAL_FILE_TYPE, 0666);
      var out = Components.classes['@mozilla.org/network/file-output-stream;1'].
        createInstance(Components.interfaces.nsIFileOutputStream);
      out.init(file, 2, 0x200, false); // open as "write only"
      
      println(out, "<opml>");
      println(out, " <body>");
      for (var i=0; i<model.size(); i++)
      {
        var feed = model.get(i);
        print(out, "  <outline");
        print(out, " text=\"" + encodeHTML(feed.defaultName) + "\"");
        println(out, " xmlUrl=\"" + encodeHTML(feed.url) + "\"/>");
      }  
      println(out, " </body>");
      println(out, "</opml>");
      out.close();
      
      alert("Successfully exported OMPL.");
    } 
    catch (err) 
    {
      alert("Export failed: " + err);
    }
  }
}

////////////////////////////////////////////////////////////////
// Import OPML
////////////////////////////////////////////////////////////////

function importOpml()
{
  var picker = Components.classes["@mozilla.org/filepicker;1"].
    createInstance(Components.interfaces.nsIFilePicker);
  picker.init(window, "Import OPML", picker.modeOpen);
  picker.appendFilter("OPML Files (*.xml, *.opml)", "*.xml;*.opml");
  picker.appendFilters(picker.filterAll);

  if(picker.show() == picker.returnOK) 
  {
    try 
    {
      var fix = Components.classes['@mozilla.org/docshell/urifixup;1'].
        getService(Components.interfaces.nsIURIFixup);
      var url = fix.createFixupURI(picker.file.path, fix.FIXUP_FLAG_ALLOW_KEYWORD_LOOKUP);

      // Locks up browser - not sure why - same code as file.js
      //var xml = document.implementation.createDocument("","",null);
      //xml.async = false;
      //xml.load(url.spec);
      
      var req = new XMLHttpRequest();
      req.open("GET", url.spec, false);
      req.overrideMimeType("application/xml");
      req.send(null);
      var xml = req.responseXML;      
      
      var kids = xml.getElementsByTagName("outline");
      for (var i=0; i<kids.length; i++)
      {
        var url = kids[i].getAttribute("xmlUrl");
        if (url == null) continue;
        createNewFeed(model, url);
      }                 
      
      saveFeedModel();
      refreshModel();     
      alert("Successfully imported OPML.");
    }
    catch (err)
    {
      alert("Import failed: " + err);
    }
  }
}

